hdu 3003 Pupu

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=3003

题目大意:一种动物身上有n种不同的皮肤,每种皮肤有透明很不透明两种状态,经过一天的日晒,透明的可以变成不透明,不透明的可以变成透明.

刚出生的动物的皮肤是不透明的,还有只有在皮肤外层是透明的时候才可以照射进去。计算出多少天后动物的皮肤全都变过透明的。

也就是等同于最后一个变过透明是即可。

推导公式:

0表示不透明的,1表示透明的。

前一个从0变1的时候后一个可以从1变到0,也就是说前一个变2次,后一个可以变一次,前一个变四次,后后一个可以变一次。。。。。以此类推。

 1 #include <iostream>
 2 #include <cstdio>
 3 using namespace std;
 4
 5 __int64 fun(__int64 a,__int64 b,__int64 c)
 6 {
 7     int s=1;
 8     while (b)
 9     {
10         if (b%2==1)
11             s=s*a%c;
12         a=a*a%c;
13         b/=2;
14     }
15     return s;
16 }
17
18 int main ()
19 {
20     __int64 n,q;
21     while (scanf("%I64d",&n),n)
22     {
23         q=fun(2,n-1,n)+1;
24         printf ("%I64d\n",q);
25     }
26     return 0;
27 }

hdu 3003 Pupu,布布扣,bubuko.com

时间: 2024-08-03 07:17:29

hdu 3003 Pupu的相关文章

HDU - 3003 - Pupu (快速幂取模!)

Pupu Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 1133    Accepted Submission(s): 445 Problem Description There is an island called PiLiPaLa.In the island there is a wild animal living in it

HDU 3003

找规律吧.可以快速幂模 #include <iostream> #include <cstdio> using namespace std; __int64 Power(__int64 a,__int64 b,__int64 k){ __int64 ans=1; a%=k; while(b){ if(b&1){ ans=ans*a%k; } b>>=1; a=a*a%k; } return ans; } int main(){ __int64 k; while(

hdu_3003Pupu(快速幂)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=3003 Pupu Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Total Submission(s): 1747    Accepted Submission(s): 688 Problem Description There is an island called PiLiPaL

深坑之---数学

本学期的数学生涯正式开始,第一个进军的毫无疑问是数论. 现在还属于学习和消化阶段,写这样零散地整理知识点,以后再总结. 1. 模算术 ( 快速幂取模 ) //在O(logn)的时间复杂度完成 a^b % m 的计算 //另外还有模算术 (a+b)%c =( a%c + b%c ) %c (a-b)%c =( a%c - b%c + c) %c (ab)%c = (a%c)(b%c) % c LL fast_mod(LL a,LL b,LL n) { LL ans = 1; while(b) {

hdu 3006 The Number of set(思维+壮压DP)

The Number of set Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 1056    Accepted Submission(s): 655 Problem Description Given you n sets.All positive integers in sets are not less than 1 and

HDU 6203 ping ping ping [LCA,贪心,DFS序,BIT(树状数组)]

题目链接:[http://acm.hdu.edu.cn/showproblem.php?pid=6203] 题意 :给出一棵树,如果(a,b)路径上有坏点,那么(a,b)之间不联通,给出一些不联通的点对,然后判断最少有多少个坏点. 题解 :求每个点对的LCA,然后根据LCA的深度排序.从LCA最深的点对开始,如果a或者b点已经有点被标记了,那么continue,否者标记(a,b)LCA的子树每个顶点加1. #include<Bits/stdc++.h> using namespace std;

HDU 5542 The Battle of Chibi dp+树状数组

题目:http://acm.hdu.edu.cn/showproblem.php?pid=5542 题意:给你n个数,求其中上升子序列长度为m的个数 可以考虑用dp[i][j]表示以a[i]结尾的长度为j的上升子序列有多少 裸的dp是o(n2m) 所以需要优化 我们可以发现dp的第3维是找比它小的数,那么就可以用树状数组来找 这样就可以降低复杂度 #include<iostream> #include<cstdio> #include<cstring> #include

hdu 1207 汉诺塔II (DP+递推)

汉诺塔II Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 4529    Accepted Submission(s): 2231 Problem Description 经典的汉诺塔问题经常作为一个递归的经典例题存在.可能有人并不知道汉诺塔问题的典故.汉诺塔来源于印度传说的一个故事,上帝创造世界时作了三根金刚石柱子,在一根柱子上从下往

[hdu 2102]bfs+注意INF

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=2102 感觉这个题非常水,结果一直WA,最后发现居然是0x3f3f3f3f不够大导致的--把INF改成INF+INF就过了. #include<bits/stdc++.h> using namespace std; bool vis[2][15][15]; char s[2][15][15]; const int INF=0x3f3f3f3f; const int fx[]={0,0,1,-1};